<template>
    <div>
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small" style="max-width: 500px;">
            <el-form-item prop="companyName" label="企业名称">
                <el-input v-model="formData.companyName" :disabled="'companyName'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="hall" label="展馆">
                <template>
                    <el-select v-model="formData.hall" clearable placeholder="请选择" :disabled="'hall'==subColumn">
                        <el-option v-for="item in hallOptions" :key="item.value" :label="item.label" :value="item.value">
                        </el-option>
                    </el-select>
                </template>
            </el-form-item>
            <el-form-item prop="boothNo" label="展位号">
                <el-input v-model="formData.boothNo" :disabled="'boothNo'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="introduce" label="公司介绍">
                <el-input type="textarea" v-model="formData.introduce" :disabled="'introduce'==subColumn"></el-input>
            </el-form-item>
            <el-form-item prop="voice" label="语音介绍">
                <el-upload class="upload-demo" :file-list="fileList" :multiple="false" :action="$baseUrl+'/assets/uploadFile'" :on-success='haleSuccess'>
                    <el-button size="small" type="primary">点击上传</el-button>
                    <div slot="tip" class="el-upload__tip">只能上传Mp4文件 </div>
                </el-upload>
            </el-form-item>
            <el-form-item prop="rank" label="排序">
                <el-input type="number" v-model="formData.rank" :disabled="'rank'==subColumn"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="$store.state.fetchingData" type="primary">保存</el-button>
                <el-button @click="onDelete" v-if="formData.id" type="danger">删除</el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
import formValidator from '../formValidator'

export default {
    created() {
        if (this.$route.query.column) {
            this.subColumn = this.$route.query.column.split(',')[1];
            this.subValue = this.$route.query.column.split(',')[0];
        }

        if (this.$route.query.id) {
            this.$http.get({
                url: '/companyInfoDetail/getOne',
                data: {
                    id: this.$route.query.id
                }
            }).then(res => {
                if (res.success) {


                    this.formData = res.data;

                    if (this.$route.query.column) {
                        this.formData[this.subColumn] = this.subValue;
                    }
                    var nameList = res.data.voice.split('/')
                    var jsonp = {
                        name: nameList[nameList.length - 1],
                        url: res.data.voice
                    }
                    this.fileList.push(jsonp)
                }
            })
        } else {
            if (this.$route.query.column) {
                this.formData[this.subColumn] = this.subValue;
            }
        }

    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                companyName:
                    [
                        { required: true, message: '请输入 企业名称', trigger: 'blur' },
                    ],
                hall:
                    [
                        { required: true, message: '请输入 展馆', trigger: 'blur' },
                    ],
                boothNo:
                    [
                        { required: true, message: '请输入 展位号', trigger: 'blur' },
                    ],
            },
            hallOptions: [{ label: '4号馆', value: '4号馆' }, { label: '5号馆', value: '5号馆' }, { label: '6号馆', value: '6号馆' }, { label: '5A馆', value: '5A馆' }],
            subColumn: '',
            subValue: '',
            fileList: []

        }
    },
    methods: {
        onSave() {
            this.$refs.form.validate((valid) => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            var data = JSON.parse(JSON.stringify(this.formData));
            this.$http.post({
                url: this.formData.id ? '/companyInfoDetail/update' : '/companyInfoDetail/save',
                data: data
            }).then(res => {
                if (res.success) {
                    this.$message.success('成功');
                    this.$router.go(-1);
                } else {
                    this.$message.warning('失败')
                }
            });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' }).then(() => {
                return this.$http.post({
                    url: '/companyInfoDetail/del',
                    data: { id: this.formData.id }
                })
            }).then(() => {
                this.$message.success('删除成功');
                this.$router.go(-1);
            }).catch(action => {
                if (action === 'cancel') {
                    this.$message.info('删除取消');
                } else {
                    this.$message.error('删除失败');
                }
            })
        },
        haleSuccess(file) {
            // console.log(file)
            file.data.forEach(item => {
                var nameList = item.split('/')
                var jsonp = {
                    name: nameList[nameList.length - 1],
                    url: item
                }
                this.fileList.splice(0, 1, jsonp)
                this.formData.voice = item
            })
        }
    }
}
</script>
<style lang="less" scoped>
</style>
